/* ISubsetsModel.java
 * Author: Nina Jeliazkova
 * Date: Nov 5, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.weka;

import org.openscience.cdk.qsar.model.IModel;

import ambit.data.molecule.IAtomContainersList;
import ambit.exceptions.AmbitException;
import chemCast.similarity.data.Subsets;

public interface ISubsetsModel extends IModel{


    public abstract Subsets getDatasets();

    public abstract void setDatasets(Subsets datasets);
    public float predict(IAtomContainersList object1, int index1, IAtomContainersList object2, int index2) throws AmbitException;

}